ghc-7.6.3: The GHC API

Safe Haskell | None

NCGMonad

# Documentation

data NatM_State

Constructors

NatM_State |
Fields natm_us :: UniqSupply natm_delta :: Int natm_imports :: [CLabel] natm_pic :: Maybe Reg natm_dflags :: DynFlags

mkNatM_State :: UniqSupply -> Int -> DynFlags -> NatM_State

data NatM result

Instances

Monad NatM |
HasDynFlags NatM |

initNat :: NatM_State -> NatM a -> (a, NatM_State)

addImportNat :: CLabel -> NatM ()

getUniqueNat :: NatM Unique

mapAccumLNat :: (acc -> x -> NatM (acc, y)) -> acc -> [x] -> NatM (acc, [y])

setDeltaNat :: Int -> NatM ()

getDeltaNat :: NatM Int

getBlockIdNat :: NatM BlockId

getNewLabelNat :: NatM CLabel

getNewRegNat :: Size -> NatM Reg

getNewRegPairNat :: Size -> NatM (Reg, Reg)

getPicBaseMaybeNat :: NatM (Maybe Reg)

getPicBaseNat :: Size -> NatM Reg

getDynFlags :: HasDynFlags m => m DynFlags